<template>
    <div class="main">
        <div class="classe">
            <h1 style="margin-bottom: 120px"> <b>Venda de Ingressos</b> </h1>
            <div class="form-row">
                <div class="form-group col-md-6">
                    <label for="inputDistancia4">Distância Pré Origem</label>
                    <input type="number" step="0.0005" class="form-control" id="inputDistancia4" placeholder="Distancia pré origem" v-model="viagem.dist_pre" readonly>
                </div>
                <div class="form-group col-md-6">
                    <label for="inputOrigem4">Distância Origem-Destino</label>
                    <input type="number" step="0.0005" class="form-control" id="inputOrigem4" placeholder="Distancia Origem-Destino" maxlength="11" v-model="viagem.dist_real" readonly>
                </div>
            </div>
            <div class="form-row">
                <div class="form-group col-md-4">
                    <label for="inputCityOrigem">Origem</label>
                    <input type="text" class="form-control" id="inputCityOrigem" v-model="viagem.origem" readonly>
                </div>
                <div class="form-group col-md-2">
                    <label for="inputParadasOrigem">Paradas Origem</label>
                    <input type="number" class="form-control" id="inputParadasOrigem" v-model="viagem.origem_estado" readonly>
                </div>
                <div class="form-group col-md-4">
                    <label for="inputCityDestino">Destino</label>
                    <input type="text" class="form-control" id="inputCityDestino" v-model="viagem.destino" readonly>
                </div>
                <div class="form-group col-md-2">
                    <label for="inputParadasDestino">Paradas Destino</label>
                    <input type="number" class="form-control" id="inputParadasDestino" v-model="viagem.destino_estado" readonly>
                </div>
            </div>
            <div class="form-row">
                <div class="form-group col-md-4">
                    <label for="inputOrcamento">Orçamento</label>
                    <input type="number" step="0.0005" class="form-control" id="inputOrcamento"  maxlength="11" v-model="viagem.orcamento" readonly>
                </div>
                <div class="form-group col-md-3">
                    <label for="inputDataSaida">Data de Saída</label>
                    <input type="date" id="inputDataSaida" class="form-control" v-model="viagem.data_s" readonly>
                </div>
                <div class="form-group col-md-3">
                    <label for="inputDataRetorno">Data de Retorno</label>
                    <input type="date" class="form-control" id="inputDataRetorno" v-model="viagem.data_r" readonly>
                </div>
                <div class='form-group col-md-2'>
                    <label for="inputHorarioSaida">Horário de Saída</label>
                    <input type="text" class="form-control" id="inputHorarioSaida" maxlength="15" v-model="viagem.hora_s" readonly>
                </div>
            </div>

            <h2 style="margin: 2%"> Adicionar </h2>
            <form @submit.prevent="salvar">
                <div class="form-row">
                    <div class="form-group col-md-3">
                        <label for="inputId">ID</label>
                        <input type="text" class="form-control" id="inputId" placeholder="id" v-model='passageiro.id'>
                    </div>
                    <div class="form-group col-md-6">
                        <label for="inputName">CPF</label>
                        <input type="text" class="form-control" id="inputCPF" placeholder="CPF" v-model='passageiro.cpf' disabled>
                    </div>
                    <div class="form-group col-md-3" style="margin-top: 32px">
                        <button class="btn btn-success">Enviar</button> &nbsp
                        <button type="button" @click="relatorioDia()" class="btn btn-warning">Relatório</button>
                    </div>
                </div>
            </form>
        </div>
        <div id="mensagem" style="color: green; margin-left: 5%">...</div>
        <table class="table" style="margin-top: 30px">
            <thead class="bg-success">
                <tr>
                    <th>ID</th>
                    <th>Nome</th>
                    <th>CPF</th>
                    <th>Ações</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="passageiro of passageiros" :key="passageiro.id">
                    <td>{{ passageiro.id }}</td>
                    <td>{{ passageiro.nome }}</td>
                    <td>{{ passageiro.cpf }}</td>
                    <td> 
                        <button type="button" @click="remover(passageiro)" class="btn btn-dark">Remover da Viagem</button>
                    </td>
                </tr>
            </tbody>
        </table>
        </div>

    
    
</template>

<script>
    import Viagem from '../services/viagens'
    import axios from 'axios'
    import { httpGet } from '../services/config'
    import jsPDF from 'jspdf';
    import autoTable from 'jspdf-autotable';

export default {

    data() {
        return {
            viagem: {
                id: '',
                passageiros: null,
                dist_pre: '',
                dist_real: '',
                origem: '',
                origem_estado: '',
                destino: '',
                destino_estado: '',
                orcamento: '',
                data_s: '',
                hora_s: '',
                data_r: ''
            },
            passageiro: {
                "id": '',
                "nome": '',
                "cpf": '',
                "rg": '',
                "nascimento": null,
                "telefone": '',
                "endereco": '',
                "cidade": ''
            },
            viagens: [],
            passageiros: [],
            errors: [],
        
        }
    },
    
    mounted (){
        this.getV();
    },

    methods:{

        getV(){
            axios.get(httpGet() + '/viagens/' + this.$route.params.id).then(resposta => {
                console.log(resposta.data);
                this.viagem = resposta.data;
                this.passageiros = resposta.data.passageiros;
            });
        },
        async salvar() {
            let novoPassageiro;
            
            axios.get(httpGet() + '/passageiros/' + this.passageiro.id).then(resposta => {
                novoPassageiro = resposta.data;
                
                this.viagem.passageiros.push(novoPassageiro);

                Viagem.atualizar(this.viagem).then(resposta => {
                        this.errors = []
                        console.log(novoPassageiro);
                        let txt = "Passageiro "+this.passageiro["nome"]+" adicionado com sucesso!"
                        document.getElementById("mensagem").textContent = txt;
                }).catch(e => {
                        this.errors = e.response.data.errors
                })
            }).catch(e => {
                alert("Erro de envio. Verifique se o ID do passageiro existe.");
            })
        },
        Atualizar_Viagem () {
            Viagem.atualizar(this.viagem).then(resposta => {
                this.errors = []
                this.passageiro = {}
                // window.location.reload()
            }).catch(e => {
                this.errors = e.response.data.errors
            })
        },
        remover(passageiro) {
            let vPassageiros = this.viagem.passageiros;
            for(let i = 0; i < vPassageiros.length; i++) {
                let obj = vPassageiros[i];
                if (obj["id"] == passageiro["id"]) {
                    this.viagem.passageiros.splice(i,1)
                    this.Atualizar_Viagem();
                }
            }
        },
        relatorioDia(){
            let pass = this.viagem.passageiros;
            let passageiros_viagem = [];
            for (let i = 0; i < pass.length; i++) {
                let obj = {
                    id: pass[i].id,
                    nome: pass[i].nome,
                    cpf: pass[i].cpf,
                    nascimento: pass[i].nascimento,
                    telefone: pass[i].telefone,
                    cidade: pass[i].cidade,
                };
                passageiros_viagem.push(obj);
            }
            let doc = new jsPDF();
            doc.setFontSize(22);
            doc.text('Passageiros Cadastrados', 65, 12);
            doc.setFontSize(16);
            doc.text('Samba Viagens', 85, 20);
            doc.setFontSize(12);
            let date = new Date;
            let data = ("00" + date.getDate()).slice(-2)+
                        "/"+("00" + Number(date.getMonth()+1)).slice(-2)+
                        "/"+date.getFullYear();
            let hora = date.getHours()+":"+date.getMinutes()+":"+date.getSeconds();
            doc.text('Data: '+data+'  Hora: '+hora, 72, 27);
            doc.setFontSize(11);
            doc.text('Código da Viagem: '+this.viagem.id+
                     '    Origem: '+this.viagem.origem+
                     '    Destino: '+this.viagem.destino, 15, 37);
            doc.text('N° de Passageiros: '+this.viagem.passageiros.length, 158, 37);
            doc.text('Data de Saída: '+this.viagem.data_s+
                     '    Hora de Saída: '+this.viagem.hora_s, 15, 44);
            let media = this.viagem.orcamento/this.viagem.passageiros.length; 
            doc.text('Média p/Passageiro: R$ '+media.toFixed(2), 140, 51);
            doc.text('Orçamento: R$'+this.viagem.orcamento.toFixed(2), 15, 51);
            doc.autoTable({
              head: [
                {
                  id: '#', 
                  nome: 'Nome', 
                  cpf: 'CPF', 
                  nascimento: 'Nascimento',
                  telefone: 'Vencimento',
                  cidade: 'Cidade'
                }
              ],
              body: passageiros_viagem,
              startY: 58,
              /* apply styling to table body */
              bodyStyles: {
                  valign: 'top'
              },
              /* apply global styling */
              styles: {
                  cellWidth: 'wrap',
                  rowPageBreak: 'auto',
                  halign: 'justify',
              },
              /* apply styling specific to table columns */
              columnStyles: {
                  text: {
                      cellWidth: 'auto'
                  }
              }
            });
            doc.output('dataurlnewwindow', "SambaOnibus_relatorio_Passageiros.pdf");
        },
    }
}
</script>

<style>
    h1 {
        text-align: center;
        margin-top: 5%;
    }

    .classe {
        background-image: url('.././assets/icon_t.png');
        background-size: 150px;
        background-repeat: no-repeat;
    }
</style>